> For the complete documentation index, see [llms.txt](https://docs.umbraco.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.umbraco.com/umbraco-ui-builder/13.latest/advanced/value-mappers.md).

# Value Mappers

Configuring value mappers in Umbraco UI Builder, the backoffice UI builder for Umbraco.

A value mapper is an Umbraco UI Builder helper class that sits between the editor UI and the database. It also lets you tweak the stored value of a field. By default Umbraco UI Builder will save a datatype value as it would be stored in Umbraco. Value mappers let you change this.

When Umbraco UI Builder resolves a value mapper it will attempt to do so from the global DI container. This means you can inject any dependencies that you require for your mapper. If there is no type defined in the DI container, Umbraco UI Builder will fall-back to manually instantiating a new instance of value mapper.

## Defining a value mapper

To define a mapper create a class that inherits from the base class `ValueMapper` and implements the methods `EditorToModel` and `ModelToEditor`.

```csharp
// Example
public class MyValueMapper : ValueMapper
{
    public override object EditorToModel(object input)
    {
        // Tweak the input and return mapped object
        ...
    }

    public override object ModelToEditor(object input)
    {
        // Tweak the input and return mapped object
        ...
    }    
}
```

## Setting a field value mapper

Value mappers are defined as part of a collection editor field configuration.

### **SetValueMapper\<TMapperType>() : EditorFieldConfigBuilder\<TEntityType, TValueType>**

Set the value mapper for the current field.

```csharp
// Example
fieldConfig.SetValueMapper<MyValueMapper>();
```

### **SetValueMapper(Type mapperType) : EditorFieldConfigBuilder\<TEntityType, TValueType>**

Set the value mapper for the current field.

```csharp
// Example
fieldConfig.SetValueMapper(typeof(MyValueMapper));
```

### **SetValueMapper(Mapper mapper) : EditorFieldConfigBuilder\<TEntityType, TValueType>**

Set the value mapper for the current field.

```csharp
// Example
fieldConfig.SetValueMapper(new MyValueMapper());
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.umbraco.com/umbraco-ui-builder/13.latest/advanced/value-mappers.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
